﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LandscapeGenerator : MonoBehaviour {

    public Material seaTexture;
    public Material forestTexture;
    public Material mountainTexture;
    public Material lakeTexture;
    public Material coastTexture;
    public Material desertTexture;
    public Material paradiseTexture;
    public Color initial;

    private const double beginForestChance = 0.95d;
    private const double beginLakeChance = 0.05d;

    private const double firstMountainChance = 0.95d;
    private const double firstSeaChance = 0.05d;

    private const double secondMountainChance = 0.9d;
    private const double secondSeaChance = 0.1d;

    private const double thirdMountainChance = 0.5d;
    private const double thirdSeaChance = 0.5d;

    private const double fourthMountainChance = 0.1d;
    private const double fourthSeaChance = 0.9d;

    private const double fifthSeaChance = 0.8d;
    private const double fifthMountainChance = 0.05d;
    private const double fifthDesertChance = 0.05d;
    private const double fifthParadiseChance = 0.1d;


    void setUpLandScape()
    {
        //       List<Cell> hexagons = this.GetCom
        Hexagon[] hexagons = GetComponentsInChildren<Hexagon>();
        foreach(Hexagon hex in hexagons)
        {
            switch (hex.type)   
            {
                case ("begin"): hex.GetComponent<MeshRenderer>().material = Random.Range(0.0f, 1.0f)  < beginForestChance    ?   forestTexture     : lakeTexture;
                    hex.GetComponent<MyHexagon>().SetColor(Color.blue); break;

                case ("1st")  : hex.GetComponent<MeshRenderer>().material = Random.Range(0.0f, 1.0f)  < firstMountainChance  ?   mountainTexture   : seaTexture;   break;

                case ("2nd")  : hex.GetComponent<MeshRenderer>().material = Random.Range(0.0f, 1.0f)  < secondMountainChance ?   mountainTexture   : seaTexture;   break;

                case ("3rd")  : hex.GetComponent<MeshRenderer>().material = Random.Range(0.0f, 1.0f)  < thirdMountainChance  ?   mountainTexture   : seaTexture;   break;

                case ("4th")  : hex.GetComponent<MeshRenderer>().material = Random.Range(0.0f, 1.0f)  < fourthMountainChance ?   mountainTexture   : seaTexture;   break; 

                case ("5th"):
                    float random = Random.Range(0.0f, 1.0f);
                    hex.GetComponent<MeshRenderer>().material = random > fifthSeaChance ?            
                                                                     seaTexture      :
                               random > fifthParadiseChance ?        paradiseTexture :
                               Random.Range(0.0f, 1.0f) < 0.5f ?     mountainTexture :
                                                                     desertTexture;
                                                                     break;
                    

            }


        }

        

    }
    // Use this for initialization
    void Start () {
        setUpLandScape();

	}
	
	// Update is called once per frame
	void Update () {

        foreach (Hexagon hex in GetComponentsInChildren<Hexagon>())
        {
            hex.GetComponent<Renderer>().material = forestTexture;
            initial = Color.red;
        }



    }
}
